> For the complete documentation index, see [llms.txt](https://docs.hackle.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.hackle.io/en/development-guide/ios/ios-optout.md).

# Opt-out

When Opt-out is enabled, the SDK stops sending all events.

## Configure at Initialization

{% tabs %}
{% tab title="Swift" %}

```swift
let config = HackleConfigBuilder()
    .optOutTracking(true)
    .build()

Hackle.initialize(sdkKey: YOUR_APP_SDK_KEY, config: config) {
    // SDK ready to use.
}
```

{% endtab %}

{% tab title="Objective-C" %}

```objectivec
HackleConfigBuilder *builder = [[HackleConfigBuilder alloc] init];
[builder optOutTracking:YES];
HackleConfig *config = [builder build];

[Hackle initializeWithSdkKey:@"YOUR_APP_SDK_KEY" config:config completion:^{
    // SDK ready to use.
}];
```

{% endtab %}
{% endtabs %}

## Runtime Opt-out Control

{% tabs %}
{% tab title="Swift" %}

```swift
hackleApp.setOptOutTracking(optOut: true)   // activate
hackleApp.setOptOutTracking(optOut: false)  // deactivate
let isOptOut = hackleApp.isOptOutTracking   // query (property, not method)
```

{% endtab %}

{% tab title="Objective-C" %}

```objectivec
[hackleApp setOptOutTrackingWithOptOut:YES];
[hackleApp setOptOutTrackingWithOptOut:NO];
BOOL isOptOut = hackleApp.isOptOutTracking;
```

{% endtab %}
{% endtabs %}

## Persistence Management

{% hint style="warning" %}
The Opt-out state changed at runtime is reset to the value configured in the initialization Config on app restart.

To persist the state across app restarts, you must implement your own save and restore logic.
{% endhint %}

{% tabs %}
{% tab title="Swift" %}

```swift
func saveOptOutState(_ optOut: Bool) {
    UserDefaults.standard.set(optOut, forKey: "hackle_opt_out")
    hackleApp.setOptOutTracking(optOut: optOut)
}

func getOptOutConfig() -> HackleConfig {
    let optOut = UserDefaults.standard.bool(forKey: "hackle_opt_out")
    return HackleConfigBuilder()
        .optOutTracking(optOut)
        .build()
}
```

{% endtab %}

{% tab title="Objective-C" %}

```objectivec
- (void)saveOptOutState:(BOOL)optOut {
    [[NSUserDefaults standardUserDefaults] setBool:optOut forKey:@"hackle_opt_out"];
    [hackleApp setOptOutTrackingWithOptOut:optOut];
}

- (HackleConfig *)getOptOutConfig {
    BOOL optOut = [[NSUserDefaults standardUserDefaults] boolForKey:@"hackle_opt_out"];
    HackleConfigBuilder *builder = [[HackleConfigBuilder alloc] init];
    [builder optOutTracking:optOut];
    return [builder build];
}
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.hackle.io/en/development-guide/ios/ios-optout.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
